---
- name: Install postgresql
  hosts: db
  gather_facts: false
  become: true
  pre_tasks:
    - name: Wait for connection
      ansible.builtin.wait_for_connection:
    - name: Collect facts
      ansible.builtin.setup:
  roles:
    - ansible_role_postgresql

- name: Install php and nginx
  hosts: app
  gather_facts: false
  become: true
  pre_tasks:
    - name: Wait for connection
      ansible.builtin.wait_for_connection:
    - name: Collect facts
      ansible.builtin.setup:
  roles:
    - ansible_role_php
    - ansible_role_nginx

- name: Openvpn server
  hosts: vpn
  gather_facts: false
  become: true
  pre_tasks:
    - name: Wait for connection
      ansible.builtin.wait_for_connection:
    - name: Collect facts
      ansible.builtin.setup:
  tasks:
    - name: Setup PKI
      ansible.builtin.include_role:
        name: "ansible_role_easyrsa"

    - name: Flush handlers
      ansible.builtin.meta: flush_handlers

    - name: Ensure openvpn dir exists
      ansible.builtin.file:
        path: "/etc/openvpn/server/"
        state: directory
        recurse: true
        owner: root
        group: root
        mode: "0755"

    - name: Copy certs to openvpn dir
      ansible.builtin.copy:
        src: "/usr/share/easy-rsa/easyrsa3/pki/{{ item.name }}"
        dest: "/etc/openvpn/server/{{ item.name | basename }}"
        mode: "{{ item.mode }}"
        remote_src: true
      loop:
        - name: ca.crt
          mode: "0644"
        - name: dh.pem
          mode: "0600"
        - name: private/server.key
          mode: "0600"
        - name: issued/server.crt
          mode: "0644"
        - name: crl.pem
          mode: "0644"

    - name: Setup vpn
      ansible.builtin.include_role:
        name: "ansible_role_openvpn"

    - name: Fetch client config
      ansible.builtin.fetch:
        src: "/etc/openvpn/server-client.ovpn"
        dest: "./"
        flat: true

    - name: Fetch client certificates
      ansible.builtin.fetch:
        src: "/usr/share/easy-rsa/easyrsa3/pki/{{ item }}"
        dest: "./"
        flat: true
      loop:
        - issued/client1.crt
        - private/client1.key

    # - name: Create IPTables NAT chain
    #   iptables:
    #     table: nat
    #     chain: POSTROUTING
    #     jump: MASQUERADE
    #     source: "0.0.0.0/0"
    #     destination: "0.0.0.0/0"
    #     protocol: "all"
    #     comment: Ansible NAT Masquerade
    #   ignore_errors: yes
